24 深度优先搜索(DFS)
题目描述
The doggie found a bone in an ancient maze, which fascinated him a lot.However, when he picked it up, the maze began to shake, and the doggie could feel the ground sinking. He realized that the bone was a trap, and he tried desperately to get out of this maze.The maze was a rectangle with sizes N by M. There was a door in the maze. At the beginning, the door was closed and it would open at the T-th second for a short period of time (less than 1 second). Therefore the doggie had to arrive at the door on exactly the T-th second. In every second, he could move one block to one of the upper,lower, left and right neighboring blocks. Once he entered a block, the ground of this block would start to sink and disappear in the next second. He could not stay at one block for more than one second, nor could he move into a visited block. Can the poor doggie survive? Please help him.
输入说明
The input consists of multiple test cases. The first line of each test case contains three integers N, M, and T (1 < N, M < 7; 0 < T < 50), which denote the sizes of the maze and the time at which the door will open, respectively. The next N lines give the maze layout, with each line containing M characters. A character is one of the following: ‘X’: a block of wall, which the doggie cannot enter; ‘S’: the start point of the doggie; ‘D’: the Door; or ‘.’: an empty block. The input is terminated with three 0’s. This test case is not to be processed.
输出说明
For each test case, print in one line “YES” if the doggie can survive, or “NO” otherwise
样例展示
样例输入:
4 4 5
S.X.
…X.
…XD
…
3 4 5
S.X.
…X.
…D
0 0 0
样例输出:
NO
YES
问题分析
题目的大意:有一个N * M的迷宫,包括起点S,终点D,墙X,和地面,0秒时主人公从S出发,每秒能走到四个与其相邻的位置的一个,且每个位置被行走之后都不能再次走入,问是否存在这样一条路径使主人公在T秒时刚好走到D。
在这个问题中,题目不再要求我们求解最优解,而是转而需要我们判断是否存在一条符合条件的路径,所以我们使用深度优先搜索来达到这个目的。
确定状态三元组(x,y,t),(x,y)是当前点坐标,t表示从起点到该点所需的时间。我们需要的目标状态为(dx,dy,T),其中(dx,dy)为D所在的坐标,T为所需的时间。初始状态(sx,sy,0),其中(sx,sy)为S所在点的坐标。
同样的,在深度优先搜索中也需要剪枝,我们同样不去理睬被我们判定不可能存在所需状态的子树,以期能够减小所需遍历的状态个数,避免不必要的超时。
我们这里注意到,主人公每走一步,其所在位置坐标中。只有一个坐标发生增1或者减1的改变,那么两个坐标分量和的奇偶性将发生变化。这样,当主人公走过奇数步时,其所在位置坐标和奇偶性必与原始位置不同;而走过偶数步时,其坐标和的奇偶性与起点保持不变。若起点的坐标和的奇偶性和终点的坐标和不同,但是需要经过偶数秒使其刚好达到,显然这是不可能的,于是我们直接判定这种情况下,整课树都不可能存在我们所需的状态,跳过搜索部分,直接输出NO
C++代码
#include<iostream>
using namespace std;
char maze[8][8];
int go[][2]={
{1,0},
{-1,0},
{0,1},
{0,-1}
};
bool success;
int n,m,t;
void dfs(int x,int y,int time) {
for(int i=0;i<4;i++) {
int nx=x+go[i][0];
int ny=y+go[i][1];
if(nx<1 || nx>n || ny<1 || ny>m) continue;
if(maze[nx][ny]=='X') continue; //墙
if(maze[nx][ny]=='D') { //门
if(time+1==t) {
success=true;
return;
}
else continue;
}
maze[nx][ny]='X';
dfs(nx,ny,time+1);
maze[nx][ny]='.';
if(success) return;
}
}
int main() {
while(scanf("%d%d%d",&n,&m,&t)!=EOF) {
if(n==0 && m==0 && t==0) break;
for(int i=1;i<=n;i++) {
scanf("%s",maze[i]+1);
}
success=false;
//终点
int sx,sy;
for(int i=1;i<=n;i++) {
for(int j=1;j<=m;j++) {
if(maze[i][j]=='D') {
sx=i;
sy=j;
}
}
}
//起点
for(int i=1;i<=n;i++) {
for(int j=1;j<=m;j++) {
if(maze[i][j]=='S' && (i+j)%2==((sx+sy)%2+t%2)%2) {
maze[i][j]='X';
dfs(i,j,0);
}
}
}
puts(success==true ? "YES":"NO");
}
return 0;
}
Leetcode题目太多,不知道如何准备高校夏令营?欢迎关注本专栏,和本小白一起准备夏令营吧! 本专题的规划如下: 截止到4月下旬:以王道考研为依托,提供夏令营机考的准备计划,打好基础 截止到5月中旬:以剑指offer进一步加强 本专题的内容如下: 1. 给出题目的在线测试链接,方面您检查代码的正确性 2. 给出题解